clc
clear all
close all
%distribuzione altezza della fusoliera in metri
distraltez=[0.70 0.98 1.12 1.49 1.57 1.42 1.17 0.93 0.68 0.44 0.19];
%distribuzione larghezza della fusoliera in metri
distrlarg=[0.72 1.19 1.28 1.30 1.30 1.26 1.05 0.84 0.62 0.42 0.20];
%calcolo della distribuzione dei perimetri della fusoliera
%approssimo la forma delle sezioni trasversali con dei rettangoli
distrperim=2*(distraltez+distrlarg);
%Calcolo dell'area bagnata della fusoliera tramite integrazione della distribuzione dei
%perimetri lungo la fusoliera
deltax=0.773;
distanza=0.776*[1 2 3 4 5 6 7 8 9 10 11];
integ(1)=0;
for i=2:size(distraltez,2);
   integ(i)=integ(i-1)+deltax*(distrperim(i-1)+distrperim(i))/2;
end
areabagnata=integ(size(distraltez,2));
disp('Area bagnata della fusoliera [m^2]: ');
disp(areabagnata);
disp('Area bagnata della fusoliera [ft^2]: ');
disp(areabagnata/(0.3048^2));
figure(1);
plot(distanza,distrperim);
title('Distribuzione perimetri della fusoliera');
xlabel('Ascissa lungo la fusoliera [m]');
ylabel('Perimetro della fusoliera [m]');
grid on