%Fase 2 del progetto:calcolo della polare del velivolo completo 
clear all
clc
%Dati gi determinati
S=177.34;
b=36;
%xacw=posizione del centro aerodinamico rapportata alla corda media aerodinamica
xacw=0.270594;
Cmacw=-0.072443;
%Gradiente retta di portanza in gradi^-1
CLaw=0.077887;
%c=corda media aerodinamica in ft
c=1.548204/0.3048;
%dati velivoli simili
HcessnaskylaneRG=8+((11*25.4/1000)/0.3048);
LcessnaskylaneRG=28+((7.5*25.4/1000)/0.3048);
Hcessnaskywagon=7+((9*25.4/1000)/0.3048);
Lcessnaskywagon=25+((7.5*25.4/1000)/0.3048);
Hcessnastationair=9+((3.5*25.4/1000)/0.3048);
Lcessnastationair=28+((3*25.4/1000)/0.3048);
Dcessnastationair=3+((8*25.4/1000)/0.3048);
Hbeechcraft=8+((3*25.4/1000)/0.3048);
Lbeechcraft=26+((8*25.4/1000)/0.3048);
Dbeechcraft=3+((6*25.4/1000)/0.3048);
Hpipersaratoga=8+((2*25.4/1000)/0.3048);
Lpipersaratoga=27+((8.5*25.4/1000)/0.3048);
Dpipersaratoga=4+((1*25.4/1000)/0.3048);
disp('Lunghezze totali di velivoli simili in ft: ');
disp(['Cessna Skylane RG: ',num2str(LcessnaskylaneRG)]);
disp(['Cessna Skywagon: ',num2str(Lcessnaskywagon)]);
disp(['Cessna Stationair: ',num2str(Lcessnastationair)]);
disp(['Beechcraft Bonanza: ',num2str(Lbeechcraft)]);
disp(['Piper Saratoga: ',num2str(Lpipersaratoga)]);
disp('Alteezze totali di velivoli simili in ft: ');
disp(['Cessna Skylane RG: ',num2str(HcessnaskylaneRG)]);
disp(['Cessna Skywagon: ',num2str(Hcessnaskywagon)]);
disp(['Cessna Stationair: ',num2str(Hcessnastationair)]);
disp(['Beechcraft Bonanza: ',num2str(Hbeechcraft)]);
disp(['Piper Saratoga: ',num2str(Hpipersaratoga)]);
disp('* * * * * * * * * *');

%Calcoli relativi alla fusoliera

lf=input('Lunghezza fusoliera in ft: ');
Wf=input('Larghezza massima fusoliera in ft: ');
x=input('Distanza del punto ad 1/4 della corda di radice dell''ala in percentuale della lunghezza totale della fusoliera: ');
disp('Consulta il diagramma 5-16 dal "Perkins" per determinare Kf');
Kf=input(['Inserisci  il valore di Kf in corrispondenza di ',num2str(x),' :']);
CMaf=Kf*Wf^2*lf/(S*c);
xacwb=xacw-(CMaf/CLaw);
CM0f=-0.080;
CMacwb=Cmacw+CM0f;
%Calcolo del numero di Re per la fusoliera in condizioni di crociera
ro=0.924;
mi=0.0000171;
V=65.3;
%Attenzione:l va espressa in metri
Re=ro*V*(lf*0.3048)/mi;
%Calcolo il numero di Mach in crociera
a=328;
M=V/a;
%VERIFICARE LA CORRETTEZZA
eps=input('Scabrezza della fusoliera (valore tipico 10e-3 in): ');
%D=diametro idraulico da esprimere in inch
Sfus=input('Massima aerea frontale della fusoliera in ft^2: ');
df=sqrt(4*Sfus/pi);
disp('Consulta l''abaco di Moody');
cffus=input(['Coefficiente d''attrito in corrispondenza dei seguenti valori -- numero di Re= ',num2str(Re),' -- scabrezza relativa= ',num2str(((lf*0.3048*1000)/25.4)/eps),' : ']);
Rwf=input(['Inserisci il fattore d''interferenza Rwf da fig. 4.1 in corrispondenza dei seguenti valori -- numero di Mach= ',num2str(M), ' -- numero di Re= ',num2str(Re),' : ']);
Sbfus=input('Area di base della fusoliera in ft^2: ');
db=sqrt(4*Sbfus/pi);
Swetfus=input('Area bagnata della fusoliera in ft^2: ');
CDbfusbase=Rwf*cffus*(1+60/((lf/df)^3)+0.0025*(lf/df))*Swetfus/S;
CDbfus=(0.029*(db/df)^3*(CDbfusbase*(S/Sfus))^0.5)*Sfus/S;
CD0fus=CDbfusbase+CDbfus;

%Calcoli relativi al piano di coda orizzontale
%Determinazione dei carichi di bilanciamento
Sh=input('Superficie del piano orizzontale di coda in ft^2: ');
bh=input('Apertura alare del piano di coda orizzontale in ft: ');
ch=input('Corda media aerodinamica del piano orizzontale di coda in ft: ');
%Converto la corda in metri per calcolare il numero di Re
ch=ch*0.3048;
Reh=ro*V*ch/mi;
ARh=bh^2/Sh;
lambdah=input('Rapporto di rastremazione del piano di coda orizzontale: ');
CL=[0:0.01:1.2];
lt=input('Distanza tra il fuoco del piano di coda orizzontale ed il fuoco dell''ala in ft: ');
xwmaxav=input('Posizione massima avanzata del baricentro rispetto al fuoco dell''ala in ft: ');
xwmaxar=input('Posizione massima arretrata del baricentro rispetto al fuoco dell''ala in ft: ');
Amaxav=[1,Sh/S;xwmaxav/c,-Sh/S*((lt-xwmaxav)/c)];
Amaxar=[1,Sh/S;xwmaxar/c,-Sh/S*((lt-xwmaxar)/c)];
for i=1:size(CL,2);
   clear tn;
   tn=[CL(i);-CMacwb];
   soluzmaxav=inv(Amaxav)*tn;
   soluzmaxar=inv(Amaxar)*tn;
   CLwmaxav(i)=soluzmaxav(1,1);
   CLhmaxav(i)=soluzmaxav(2,1);
   CLwmaxar(i)=soluzmaxar(1,1);
   CLhmaxar(i)=soluzmaxar(2,1);
end

%Calcolo del coefficiente di resistenza della fusoliera dovuto alla portanza;
Splfus=input('Area della forma in pianta della fusoliera in ft^2: ');
eta=input(['Inserisci il fattore \eta da fig. 4.19 in corrispondenza di lf/df= ',num2str(lf/df),' : ']);
cdc=1.2;
%Ad ogni CL che ho assegnato ho ricavato CLw e,dalla curva di portanza dell'ala
%a tale CLw posso associare un alphaw
%alpha che compare nella prossima formula  l'angolo d'attacco della fusoliera
%tale angolo  pari a (alphaw-iw) con iw=angolo di calettamento alla radice
%iw in gradi
%alphaw in gradi,perche CLaw  in gradi^-1
iw=3.25;
%CLw=CLaw*alphaw:
alphawmaxav=CLwmaxav/CLaw;
alphawmaxar=CLwmaxar/CLaw;
alphabmaxav=alphawmaxav-iw;
alphabmaxar=alphawmaxar-iw;

%Esprimo alphab in radianti come richiesto dalla formula
alphabmaxav=alphabmaxav*pi/180;
alphabmaxar=alphabmaxar*pi/180;
%Calcolo CD della fusoliera dovuto alla portanza
CDLfusmaxav=2*alphabmaxav.^2*Sbfus/S+eta*cdc*alphabmaxav.^3*Splfus/S;
CDLfusmaxar=2*alphabmaxar.^2*Sbfus/S+eta*cdc*alphabmaxar.^3*Splfus/S;
%Calcolo CD fusoliera totale (attrito+res.indotta)
CDfusmaxar=CDLfusmaxar+CD0fus;
CDfusmaxav=CDLfusmaxav+CD0fus;

%OUTPUT

figure(1);
plot(CL,CLwmaxav,'black',CL,CLwmaxar,'--black',CL,CLhmaxav,'b',CL,CLhmaxar,'--b');
title('Coefficienti di portanza dell''ala e del piano di coda orizzontale');
xlabel('CL Coefficiente di portanza totale (ala+piano di coda)');
ylabel('CLh,CLw');
grid on;
legend('CL ala per CG max avanzato','CL la per CG max arretrato','CL piano di coda per CG max avanzato','CL piano di coda per CG max arretrato');
Cd0h=input(['Coefficiente di resistenza Cd0 (2D) del profilo medio del piano orizzontale di coda - Re= ',num2str(Reh),' : ']);
CD0h=Cd0h*Sh/S;
u=input(['Fattore u (vedi Abbott pag 17-fig.10)in corrispondenza dei seguenti valori - AR= ',num2str(ARh),' - rapporto di rastremazione= ',num2str(lambdah),' : ']);
CDihmaxav=(CLhmaxav.^2/(pi*ARh*u))*(Sh/S);
CDihmaxar=(CLhmaxar.^2/(pi*ARh*u))*(Sh/S);
CDhmaxav=CD0h+CDihmaxav;
CDhmaxar=CD0h+CDihmaxar;
figure(2);
plot(CDhmaxav,CL,'black',CDhmaxar,CL,'b');
title('Polare del piano orizzontale di coda in funzione del CL totale');
xlabel('CD piano orizzontale');
ylabel('CL');
grid on;
legend('Posizione del CG massima avanzata','Posizione del CG massima arretrata');
figure(3);
plot(CDfusmaxav,CL,'black',CDfusmaxar,CL,'b');
title('Polare della fusoliera in funzione del CL totale');
xlabel('CD fusoliera');
ylabel('CL');
grid on;
legend('Posizione del CG massima avanzata','Posizione del CG massima arretrata');

%Calcoli relativi al piano verticale di coda

Sv=input('Superficie del piano verticale di coda in ft^2: ');
bv=input('Apertura alare del piano verticale di coda in ft: ');
cv=input('Corda media aerodinamica del piano verticale di coda in ft: ');
%Converto la corda in metri per calcolare il numero di Re
cv=cv*0.3048;
Rev=ro*V*cv/mi;
Cd0v=input(['Coefficiente di resistenza Cd0 (2D) del profilo medio del piano verticale di coda - Re= ',num2str(Rev),' : ']);
CD0v=Cd0v*Sv/S;


%caricamento polare indotta dell'ala
load Cl;
load Cdi;
CD0w=0.0058;
CDiwmaxav=spline(Cl,Cdi,CLwmaxav);
CDiwmaxar=spline(Cl,Cdi,CLwmaxar);
%Calcolo polare completa
CDmaxav=CD0fus+CD0v+CD0h+CD0w+CDiwmaxav+CDihmaxav+CDLfusmaxav;
CDmaxar=CD0fus+CD0v+CD0h+CD0w+CDiwmaxar+CDihmaxar+CDLfusmaxar;
figure(4);
plot(CDmaxav,CL,'r',CDmaxar,CL,'b');
title('Polare del velivolo completo');
xlabel('CD');
ylabel('CL');
legend('Baricentro massimo avanzato','Baricentro massimo arretrato');
grid on;

figure(5);
plot(CDmaxav,CL.^2,'r',CDmaxar,CL.^2,'b');
title('Polare del velivolo completo');
xlabel('CD');
ylabel('CL^2');
legend('Baricentro massimo avanzato','Baricentro massimo arretrato');
grid on;


disp('Coefficienti della polare tecnica del velivolo');
disp('CD=CD0+K*CL^2');
disp('CD0=0.0291');
disp('K=0.0505');

figure(6);
CDtecnico=0.0291+0.0505*CL.^2;
plot((CDmaxav+CDmaxar)/2,CL.^2,'r',CDtecnico,CL.^2,'b');
title('Polare del velivolo completo');
xlabel('CD');
ylabel('CL^2');
legend('Polare velivolo completo','Polare tecnica');
grid on;

figure(7);
plot((CDmaxav+CDmaxar)/2,CL,'b',CDtecnico,CL,'r');
grid on;
legend('Polare del velivolo completo','Polare tecnica');
xlabel('CD');
ylabel('CL');
title('Polare del velivolo');