%Calcolo degli sforzi di barra
%Il piano di coda orizzontale  costituito da parte fissa+parte mobile+trim
clc
clear all
close all
bt=input('Apertura piano di coda [m]: ');
St=input('Superficie piano di coda [m^2]: ');
be=input('Apertura equilibratore [m]: ');
AR=bt^2/St;
ct=input('Corda piano orizzontale [m]: ');
ce=input('Corda parte mobile (incluso trim) [m]: ');
ctrim=input('Corda trim [m]: ');
cf=input('Distanza cerniera-bordo d''uscita trim [m]: ');
cb=input('Distanza cerniera-bordo d''attacco parte mobile [m]: ');
t=input('Spessore equilibratore [m]: ');
Se=input('Superficie equilibratore [m^2]: ');

%Rapporto di cinematismo in rad/m;valore tipico appunti pag.26
G=1.64;

%DATI GIA' CALCOLATI

W=15165;
S=16.47;
tau=0.55;
ro=1.25;
etat=0.95;%fattore di riduzione della pressione dinamica in coda
Cm0w=-0.123943; %Cm velivolo parziale
alpha0w=0.0292; %angolo portanza nulla in radianti! (va preso positivo!)
c=1.5482;%corda media aerodinamica
desuda=0.36;
%---------------

%l=distanza fuochi non adimensionale!
l=4.883;
%at=pendenza retta di portanza p.c in 1/
at=0.1;
rappvolumetr=(St*l)/(S*c); %rapporto volumetrico del piano orizzontale di coda
aw=0.077887; %pendenza retta di portanza dell'ala [1/]
k=1/(1+(at*St*(1-desuda))/(aw*S));
Cmdelta=-at*rappvolumetr*k*tau; %in 1/
%converto Cmdelta in rad^-1
Cmdelta=Cmdelta*360/(2*3.14);
%--------------------
xcg2=0.24; %posizione baricentro intermedia
xacvp=0.1961; %posizione del centro aerodinamico del velivolo parziale in %c
xa2=xcg2-xacvp;
a=aw*(1+(at*St*(1-desuda))/(aw*S));
Cmcl=xa2-(at/a)*(1-desuda)*rappvolumetr;
%In Cmcl ci sono rapporti adimensionali: dunque gi espresso in rad^-1!!!

%Ch0=0 perch il piano di coda  simmetrico
Ch0=0;
%it0=angolo calettamento piano di coda (parte fissa)
it0=-0.0412; %in radianti
%lt=distanza CG in posizione intermedia-fuoco piano di coda non adimensionale!
lt=4.929;
ae=aw*l/lt;
ae=ae*360/(2*pi);
%Converto at in rad^-1 e lo correggo tenendo conto degli effetti di AR
at=at*360/(2*pi);
at=at/(1+57.3*at/(AR*pi));

%CALCOLO ANGOLO DI TRIM

Vtrim=input('Velocit di trimmaggio [Km/h]: ');
Vtrim=Vtrim*1000/3600;
q=0.5*ro*Vtrim^2;
Chalpha=-0.3430;  %in rad^-1
Chdelta=-0.6886;  %in rad^-1
Chdeltat=-0.8789; %in rad^-1

%Calcolo angolo di trim

%it=angolo retta port.nulla velivolo parziale-retta port.nulla piano di coda
deltae=(alpha0w-it0)/tau-Cm0w/Cmdelta-Cmcl/Cmdelta*W/(S*q);%angolo di deflessione
%per ottenere l'equilibrio al beccheggio
it=it0+tau*deltae; %in radianti
deltat=-1/Chdeltat*(Ch0+Chalpha*(-alpha0w-Cm0w/aw*c/lt+W/(ae*S*q)*(1-desuda)+...
   Cm0w*c*desuda/(l*aw)+it)+Chdelta*((alpha0w-it0)/tau-Cm0w/Cmdelta-Cmcl/Cmdelta*W/(S*q)));

%OUTPUT
disp('Angolo di trim in gradi: ');
disp(deltat*360/(2*pi));
Vstallo=33;
Vt=[Vstallo:Vtrim/10:Vtrim+20];

sforzo=-G*Se*ce*0.5*ro*Vt.^2*etat.*(Ch0+Chalpha*(-alpha0w-Cm0w/aw*c/lt+2*W./(ae*S*ro*Vt.^2)*(1-desuda)+...
   Cm0w*c*desuda./(l*aw)+it)+Chdelta*((alpha0w-it0)/tau-Cm0w/Cmdelta-Cmcl./Cmdelta*2*W./(S*ro*Vt.^2))+...
   Chdeltat*deltat);

figure(1);
plot(Vt*3600/1000,sforzo/10,'b');
grid on;
title('Diagramma dello sforzo di barra in funzione della velocit');
xlabel('Velocit [Km/h]');
ylabel('Sforzo di barra [Kg]');
